package com.cwbuyer.adapter;

import java.util.ArrayList;
import java.util.LinkedList;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.cwbuyer.format.AccData;
import com.cwbuyer.format.PpriData;
import com.cwbuyer.lib.Utilis;
import com.pwbuyer.main.R;

public class PpriAdapter extends BaseAdapter {
	private Context mContext;
	private LayoutInflater mInflater;
	
	private LinkedList<PpriData> mList = new LinkedList<PpriData>(); 
	
	public PpriAdapter(Context context) {
	      /* Ѽƪl */
	      mInflater = LayoutInflater.from(context);
	      mContext = context;
	}
	
	
	public void getData(Context context){
		if(mList != null){
			mList.clear();
		}
		SQLiteDatabase db = Utilis.getDB(context);
		
		Cursor cursor = null;
		cursor = db.rawQuery("select * from qc_ppri order by BPRI", null);
		
		if(cursor != null){
			try{
				if(cursor.getCount() > 0){
					cursor.moveToFirst();
					for(int i = 0; i < cursor.getCount(); i++){
						PpriData data = new PpriData();
						data.id = cursor.getInt(cursor.getColumnIndex("_ID"));
						data.icon = cursor.getString(cursor.getColumnIndex("PIC"));
						data.bpri = cursor.getString(cursor.getColumnIndex("BPRI"));
						data.apri = cursor.getString(cursor.getColumnIndex("APRI"));
						data.year = cursor.getString(cursor.getColumnIndex("YEAR"));
						data.season = cursor.getString(cursor.getColumnIndex("SEASON"));
						mList.add(data);
						cursor.moveToNext();
					}
				}
			}catch(Exception e){
				
			}finally{
				cursor.close();
				cursor = null;
			}
		}
		db.close();
		db = null;
	}
	
	public int getID(int position){
		return mList.get(position).id;
	}
	
	public String getBpri(int position){
		return mList.get(position).bpri;
	}

	public String getApri(int pos){
		return mList.get(pos).apri;
	}
	
	public String getYear(int position){
		return mList.get(position).year;
	}

	public String getSeason(int position){
		return mList.get(position).season;
	}

	public int getCount() {
		return mList.size();
	}

	public Object getItem(int position) {
		return position;
	}

	public long getItemId(int position) {
		return position;
	}
	
	

	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder;
		if (convertView == null) {
			convertView = mInflater.inflate(R.layout.list_code_ppri, null);	
			holder = new ViewHolder();
			holder.icon = (ImageView) convertView.findViewById(R.id.img_ppri);
			holder.textBpri = (TextView) convertView.findViewById(R.id.text_bpri);
			holder.textApri = (TextView) convertView.findViewById(R.id.text_apri);
			holder.textYear = (TextView) convertView.findViewById(R.id.text_year);
			holder.textSeason = (TextView) convertView.findViewById(R.id.text_season);
			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}
		
		PpriData data = mList.get(position);
		try{
			holder.icon.setImageDrawable(Utilis.getResourceImage(mContext, data.icon));
		}catch(Exception e){
			e.printStackTrace();
		}
		String[] mSeason = new String[]{"K","L","","V","|u"};
		
		holder.textBpri.setText(":"+data.bpri);
		holder.textApri.setText("S:"+data.apri);
		holder.textYear.setText("~:"+data.year);
		holder.textSeason.setText(mSeason[Utilis.toInt(data.season)]);
		
		return convertView;
	}

	/* class ViewHolder */
	private class ViewHolder {
		ImageView icon;
		TextView textBpri;
		TextView textApri;
		TextView textYear;
		TextView textSeason;
	}
}
