package com.cwbuyer.lib;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.NetworkInterface;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;
import java.net.URL;
import java.net.URLConnection;
import java.net.UnknownHostException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.UUID;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;

import org.apache.http.conn.util.InetAddressUtils;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningServiceInfo;
import android.app.AlertDialog;
import android.content.ComponentName;
import android.content.ContentValues;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.content.pm.ActivityInfo;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.Bitmap.CompressFormat;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.media.ExifInterface;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Environment;
import android.os.Vibrator;
import android.preference.PreferenceManager;
import android.provider.MediaStore;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.DatePicker;
import android.widget.Toast;

import com.cwbuyer.format.IDateDialog;
import com.cwbuyer.format.IDialog;
import com.pwbuyer.main.R;

public class Utilis {
	
	public static void runVibrate(Context context) {
		try {
			String s = Utilis.getStringSet(context, "vibrator_preference", "30");
		    if (!s.equals("0")) {
				Vibrator vibrator = (Vibrator) context
						.getSystemService(context.VIBRATOR_SERVICE);
				vibrator.vibrate(Integer.valueOf(30));
		    }
		} catch (Exception e) {
		}
	}
	
	public static Bitmap exifToDegrees(String pathP,Bitmap bitmap,int exifOrientation) {
		int nPicDegree=exifOrientation;
		Bitmap bitmapR=null;
	    if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_90) { nPicDegree=90; } 
	    else if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_180) {  nPicDegree=180; } 
	    else if (exifOrientation == ExifInterface.ORIENTATION_ROTATE_270) { nPicDegree=270; }

		Matrix matrix = new Matrix();
		matrix.preRotate(nPicDegree);
		bitmapR = Bitmap.createBitmap(bitmap, 0, 0, 210, 280, matrix, true);

        FileOutputStream fos = null;
		try {
			fos = new FileOutputStream(pathP);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    try {
	    	bitmapR.compress(CompressFormat.JPEG, 100, fos);
					fos.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	    return bitmapR;    
	 }
	
	public static Drawable getResourceImage(Context cnt, String res) {
		int imageResource = cnt.getResources().getIdentifier(res, null,cnt.getPackageName());
		Drawable image = null;
		if(res.indexOf("drawable/") < 0){ // NoӤO Resource
			Bitmap bmp = getLimitBitmap(res, 200, 200);
			if(bmp != null){
				image = new BitmapDrawable(bmp);
			}
		}else{
			image = cnt.getResources().getDrawable(imageResource);
		}
		return image;
	}
	
    // M
    private static int mYear = 0;
    private static int mMonth = 0;
    private static int mDay = 0;
    
 //  SpinerDialog
    public static void showDateDialog(Context cnt, String title, Calendar c, final IDateDialog callback){
    	View view = LayoutInflater.from(cnt).inflate(R.layout.search_date_dialog, null, false);
//    	Calendar c = Calendar.getInstance();
//    	c.set(Calendar.DAY_OF_MONTH, 1); // 
    	mYear = c.get(Calendar.YEAR);
    	mMonth = c.get(Calendar.MONTH) + 1;
    	mDay = c.get(Calendar.DAY_OF_MONTH);
    	
    	DatePicker dp1 = (DatePicker)view.findViewById(R.id.dp1);
		dp1.init(mYear, mMonth - 1, mDay, new DatePicker.OnDateChangedListener() {
			@Override
			public void onDateChanged(DatePicker view, int year,
					int monthOfYear, int dayOfMonth) {
				mYear = year;
				mMonth = monthOfYear + 1;  //`N : [ܷܰʷ|֤@Ӥ
				mDay = dayOfMonth;
			}
		});
    	
		new AlertDialog.Builder(cnt).setTitle(title)
		.setView(view)
		.setPositiveButton("T{", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            	String startDay = "" + mYear + "-" + Utilis.format("" + mMonth) + "-" + Utilis.format("" + mDay);
//            	String endDay = mYear2 + "/" + Utilis.format(mMonth2) + "/" + Utilis.format(mDay2);
//            	mAdapter.getSearchDate(ManageCustom.this, startDay, endDay);
            	callback.onDateDialogFinish(startDay, mYear, mMonth, mDay);
            }
          }).setNegativeButton("", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            }
          }).show();
    }
	
	private static boolean createFolder(String strPath){
		boolean bSuccess = false;
		File file = new File(strPath.toString());
		if(file.exists() == true){
			bSuccess = true;
		}else{
			bSuccess = file.mkdirs();
		}
		return bSuccess;
	}
	
	private static void saveToExternal(InputStream is, String strFullPath){
		File file = new File(strFullPath);
		try{
			if(file.exists() == true){
//				return;
			}
			else{
				if(file.createNewFile() == false)
					return;
			}
			
			if(file.exists() == true){
				FileOutputStream fos = new FileOutputStream(file);
				byte[] buf = new byte[1024];   
				int nLength = 0;
				while((nLength = is.read(buf)) > 0){
					fos.write(buf,0,nLength);
				}
				fos.flush();
				fos.close();
			}
		}catch(IOException e){
			
		}
	}
	
	private static InputStream returnStream(String path) {
		InputStream is = null;
		try {
			URL url = new URL(path);
			URLConnection conn = url.openConnection();
			conn.connect();
			is = conn.getInputStream();

		} catch (IOException e) {
			e.printStackTrace();
		}
		return is;
	}

	
	  public static void setAutoRotationMode(Activity activity) {
//			int screen = Utils.getIntSet(this, "screen_orientation_preference", 1);
		int screen = Integer.valueOf(Utilis.getStringSet(activity, "screen_orientation_preference", "1"));
//		Toast.makeText(activity, "Change Screen : " + screen, Toast.LENGTH_SHORT).show();
		switch(screen){
		case 1:
			activity.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
			break;
		case 2:
			activity.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
			break;
		case 3:
			activity.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR);
			break;
		}
	  }


	  /*
	   * Ĥ@ϥΰT
	   */
	  public static void firstUseMsg(final Context context, final String iniTag, String Msg) {
	    String s = Utilis.getStringSet(context, iniTag, "0");
	    if (s.equals("0")) {
	      new AlertDialog.Builder(context).setTitle(context.getString(R.string.sys_msg_firstuse_title)).setMessage(Msg).setPositiveButton(context.getString(R.string.sys_msg_firstuse_cancel), new DialogInterface.OnClickListener() {
	        public void onClick(DialogInterface dialog, int which) {
	        }
	      }).setNegativeButton(context.getString(R.string.sys_msg_firstuse_ok), new DialogInterface.OnClickListener() {
	        public void onClick(DialogInterface dialog, int which) {
	          Utilis.setStringSet(context, iniTag, "1");
	        }
	      }).show();
	    }
	  }
	  
	  // W[
	  public static String addMonth(String date, int value){
		try {
			String[] dates = date.split("/");
			Calendar time = Calendar.getInstance();
			time.set(Calendar.YEAR, Integer.valueOf(dates[0]));
			time.set(Calendar.MONTH, Integer.valueOf(dates[1])-1);
			time.set(Calendar.DAY_OF_MONTH, 1);
			time.add(Calendar.MONTH, value);
			time.add(Calendar.DATE, -1);   // 

			int year = time.get(Calendar.YEAR);
			int month = time.get(Calendar.MONTH);
			int day = time.get(Calendar.DAY_OF_MONTH);

			return "" + year + "/" + Utilis.format(month + 1) + "/"
					+ Utilis.format(day);
		} catch (Exception e) {
			return "";
		}
	  }
	  
	  // W[
	  public static String addMonth(String date, int value, boolean toFirst){
		try {
			String[] dates = date.split("/");
			Calendar time = Calendar.getInstance();
			time.set(Calendar.YEAR, Integer.valueOf(dates[0]));
			time.set(Calendar.MONTH, Integer.valueOf(dates[1])-1);
			time.set(Calendar.DAY_OF_MONTH, Integer.valueOf(dates[2]));
			// [FȤᵥŪܤ
			time.add(Calendar.MONTH, value);
			if(toFirst == true){
				time.set(Calendar.DAY_OF_MONTH, 1);
			}

			int year = time.get(Calendar.YEAR);
			int month = time.get(Calendar.MONTH);
			int day = time.get(Calendar.DAY_OF_MONTH);

			return "" + year + "/" + Utilis.format(month + 1) + "/"
					+ Utilis.format(day);
		} catch (Exception e) {
			return "";
		}
	  }
	  
	  // W[
	  public static String addDate(String date, int value){
		  try {
				String[] dates = date.split("/");
				Calendar time = Calendar.getInstance();
				time.set(Calendar.YEAR, Integer.valueOf(dates[0]));
				time.set(Calendar.MONTH, Integer.valueOf(dates[1]) - 1);
				time.set(Calendar.DAY_OF_MONTH, Integer.valueOf(dates[2]));
				// [FȤᵥŪܤ
				time.add(Calendar.DAY_OF_YEAR, value);

				int year = time.get(Calendar.YEAR);
				int month = time.get(Calendar.MONTH) + 1;
				int day = time.get(Calendar.DAY_OF_MONTH);
					return "" + year + "/" + Utilis.format(month) + "/"
							+ Utilis.format(day);
			} catch (Exception e) {
				return "";
			}  
	  }
	  
	// RETURN  1  eɶj
	// RETURN  -1 ᭱ɶj
	// RETURN  0  ɶ@
	  public static int compareTime(String date1, String date2){
			try{
				if(date1 == null && date2 == null){
					return 0;
				}else if(date1 == null && date2 != null){
					return -1;
				}else if(date1 != null && date2 == null){
					return 1;
				}
				if(date1.length() > 0 && date2.length() > 0){
					long lTime1 = toFormatTime (date1);
					long lTime2 = toFormatTime (date2);
					
					if(lTime1 > lTime2){
						return 1;
					}else if(lTime1 == lTime2){
						return 0;
					}else{ 
						return -1;
					}
				}else{
					if(date1.length() <= 0 && date2.length() <= 0){
						return 0;
					}else if(date1.length() > 0){
						return 1;
					}else{
						return -1;
					}
				}
			}catch(Exception e){
				return 1;
			}
		}
	  
	  // 2012/07/04
	  // nAgoY
	  public static String toDBDate(String date){
		  return date.replace("/", "-");
	  }
	  
	  public static void reCNT(Context context){
		  int reCNT=toInt(getIni(context, "SYS", "IMEI", 7))+1;
		  Utilis.putIni(context, "SYS", "IMEI", ""+reCNT, 7);
	  }
	  
	  public static long toFormatTime(String time){
			// date = new String ("2011/01/06 12:31")
			//GregorianCalendar `N @O 0 GO 1 , H QGO 11
			GregorianCalendar calendar = new GregorianCalendar(
				 Integer.parseInt(time.substring(0,4)),   // year
				 Integer.parseInt(time.substring(5,7)) - 1,   // month
				 Integer.parseInt(time.substring(8,10)),  // day
				 0, // hour
				 0, // minute
				 0); // second
			Date date = calendar.getTime();
			long lTime = date.getTime();
			return lTime;
		}
	  
	  // ot
	  public static int getDifferDay(String dateString1, String dateString2){
		  int diff = 0;
		  try{
			  SimpleDateFormat  sdf = new SimpleDateFormat( "yyyy/MM/dd");
//			  SimpleDateFormat  sdf = new SimpleDateFormat( "yyyy-MM-dd   HH:mm:ss "); 
			  Date   date1 =  sdf.parse(dateString1); 
			  Date   date2 =  sdf.parse(dateString2); 
			  diff = (int)((date1.getTime() -date2.getTime())/(1000*3600*24));
		  }catch(Exception e){
		  }
		  return diff;
	  }

	// oثe
	public static String getCurrentDateDB() {
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		Integer mYear = c.get(Calendar.YEAR);
		Integer mMonth = c.get(Calendar.MONTH);
		Integer mDay = c.get(Calendar.DAY_OF_MONTH);
		resultStr = new StringBuilder().append(mYear).append("-")
				.append(Utilis.format(mMonth + 1)).append("-")
				.append(Utilis.format(mDay));
		return resultStr.toString();
	}
	
	// oثe
	public static  String getCurrentDate(){
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		Integer mYear = c.get(Calendar.YEAR);
		Integer mMonth = c.get(Calendar.MONTH);
		Integer mDay = c.get(Calendar.DAY_OF_MONTH);
		resultStr = new StringBuilder().append(mYear).append("/")
				.append(Utilis.format(mMonth + 1)).append("/").append(Utilis.format(mDay));
		return resultStr.toString();
	}
	
	// oثetŸ
	public static  String getCurrentDateFormat(){
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		Integer mYear = c.get(Calendar.YEAR);
		Integer mMonth = c.get(Calendar.MONTH);
		Integer mDay = c.get(Calendar.DAY_OF_MONTH);
		resultStr = new StringBuilder().append(mYear).append(Utilis.format(mMonth + 1)).append(Utilis.format(mDay));
		return resultStr.toString();
	}
	
	// oثetŸ  B~ץu1X
	public static  String getCurrentYearFormat(){
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		int mYear = c.get(Calendar.YEAR);
		int mMonth = c.get(Calendar.MONTH);
		int mDay = c.get(Calendar.DAY_OF_MONTH);
		resultStr = new StringBuilder().append((mYear % 10)).append(Utilis.format(mMonth + 1)).append(Utilis.format(mDay));
		return resultStr.toString();
	}
	
	// o몺̫@
	public static  String getCurrentLastDate(){
		StringBuilder resultStr = new StringBuilder().append("");
		Calendar c = Calendar.getInstance();
		c.set(Calendar.DAY_OF_MONTH, 1);
		c.add(Calendar.MONTH, 1);
		c.add(Calendar.DATE, -1);   // 
		
		Integer mYear = c.get(Calendar.YEAR);
		Integer mMonth = c.get(Calendar.MONTH);
		Integer mDay = c.get(Calendar.DAY_OF_MONTH);
		
		resultStr = new StringBuilder().append(mYear).append("/")
				.append(Utilis.format(mMonth + 1)).append("/").append(Utilis.format(mDay));
		return resultStr.toString();
	}
	
	
	// pGs < now ~nhs
	public static boolean compareDate(String now, String cdate){
		try{
			String[] timeNow = now.split("/");
			String[] time2 = cdate.split("/");
			
			if(Integer.valueOf(time2[0]) < Integer.valueOf(timeNow[0])){
				// ~
				return true;
			}else if(Integer.valueOf(time2[1]) < Integer.valueOf(timeNow[1])){
				// 
				return true;
			}else if(Integer.valueOf(time2[2]) < Integer.valueOf(timeNow[2])){
				// 
				return true;
			}else{
				return false;
			}
		}catch(Exception e){
			return false;
		}
	}

	// pGs < now ~nhs
	public static boolean compare_Date(String now, String cdate){
		try{
			String[] timeNow = now.split("-");
			String[] time2 = cdate.split("-");
			
			if(Integer.valueOf(time2[0]) < Integer.valueOf(timeNow[0])){
				// ~
				return true;
			}else if(Integer.valueOf(time2[1]) < Integer.valueOf(timeNow[1])){
				// 
				return true;
			}else if(Integer.valueOf(time2[2]) < Integer.valueOf(timeNow[2])){
				// 
				return true;
			}else{
				return false;
			}
		}catch(Exception e){
			return false;
		}
	}
	
	
	
	public static String getCurrentTime(){
		StringBuffer buf = new StringBuffer();
		Calendar c = Calendar.getInstance();
		int year = c.get(Calendar.YEAR);
		int month = c.get(Calendar.MONTH);
		int day = c.get(Calendar.DAY_OF_MONTH);
		int hour = c.get(Calendar.HOUR);
		int minute = c.get(Calendar.MINUTE);
		
		buf.append(year).append("/").append(month+1).append("/").append(day).append(" ");
		buf.append(hour).append(":").append(minute);
		
		return buf.toString();
	}
	
	private static String uniqueID = null;
	private static final String PREF_UNIQUE_ID = "PREF_UNIQUE_ID";
	
	public synchronized static String id(Context context){
		if(uniqueID == null){
			SharedPreferences sp = context.getSharedPreferences(
					PREF_UNIQUE_ID, Context.MODE_PRIVATE);
			uniqueID = sp.getString(PREF_UNIQUE_ID, null);
			if(uniqueID == null){
				uniqueID = UUID.randomUUID().toString();
				Editor editor = sp.edit();
				editor.putString(PREF_UNIQUE_ID, uniqueID);
				editor.commit();
			}
		}
		return uniqueID;
	}
	
	
	public static String getDateTime(String date){
		String[] dates = date.split("/");
		if(dates.length >= 3){
			StringBuffer buf = new StringBuffer();
			buf.append(dates[0]).append("-");
			buf.append(format(dates[1])).append("-");
			buf.append(format(dates[2]));
			return buf.toString();
		}else{
			return date;
		}
	}
	
	public static String chkString(String strChk){
		if(strChk != null && strChk.length() > 0){
			return strChk;
		}else{
			return "";
		}
	}
	
	// T{ഫƦr ܤ֬ 0 
	public static int valuesInt(String strChk){
		if(strChk != null && strChk.length() > 0){
			try{
				return Integer.valueOf(strChk);
			}catch(Exception e){
				return 0;
			}
		}else{
			return 0;
		}
	}
	
	public static int chkInt(int nChk){
		if(nChk >= 0){
			return nChk;
		}else{
			return 0;
		}
	}
	
	public static SQLiteDatabase getDB(Context context) {
	    try {
	    	String mDBPath=null;	
	    	mDBPath=android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+getIni(context,"SYS","YEAR",4);
	    	File file = new File(mDBPath);	      
	      return SQLiteDatabase.openOrCreateDatabase(file, null);
	      
	    } catch (SQLException e) {
	      return null;
	    }
	}

	/*
	 * Rɮ
	 */
	public static boolean DeleteFile(String fileName) {
		try {
			File zipFile = new File(fileName);
			if (zipFile.exists()) {
				return zipFile.delete();
			} else {
				return true;
			}
		} catch (Exception e) {
			return false;
		}
	}

	public static String getPackageName(Context context) {
		return context.getString(R.string.app_package);
	}
	
	// LonWǨ Server r!
	public static String filterStr(String data){
		if(data != null){
			String target = data.replace("&", "%26");
			return target;
		}else return null;
	}
	
	public static String reverStr(String data){
		if(data != null){
			String target = data.replace("%26", "&");
			return target;
		}else return null;
	}
	
	public static String format(String s) {
		if (s.length() == 1)
			s = "0" + s;
		return s;
	}
	
	public static String format(int n) {
		String s = String.valueOf(n);
		if (s.length() == 1)
			s = "0" + s;
		return s;
	}
	
	// SOFyBz
	public static String formatFlow(int n) {
		String s = String.valueOf(n);
		if (s.length() == 1){
			s = "0000" + s;
		}else if(s.length() == 2){
			s = "000" + s;
		}else if(s.length() == 3){
			s = "00" + s;
		}else if(s.length() == 4){
			s = "0" + s;
		}
		return s;
	}
	
	public static String ordFlow(int n) {
		String s = String.valueOf(n);
		if (s.length() == 1){
			s = "00" + s;
		}else{
			s = "0" + s;
		}
		return s;
	}
	
	public static String getIMEI(Context context){
		String imei;
		TelephonyManager tm = (TelephonyManager)context.getSystemService(Context.TELEPHONY_SERVICE);  
		imei = "" + tm.getDeviceId();  //DeviceId(IMEI)
		
		return imei;
	}

	/*
	 * P_S
	 */
	public static boolean haveInternet(Context context) {
		boolean result = false;
		ConnectivityManager connManager = (ConnectivityManager) context
				.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo info = connManager.getActiveNetworkInfo();
		if (info == null || !info.isConnected()) {
			result = false;
		} else {
			if (!info.isAvailable()) {
				result = false;
			} else {
				result = true;
			}
		}
		return result;
	}
	
	public static String copyDBtoSDCard(Context context) {
		String tDBZipPath ="";
		try {
			// oSD Card|
			String tSDCardPath = android.os.Environment.getExternalStorageDirectory().getAbsolutePath();
			// wSD CardPؼХؿW
			File tDataPath = new File(tSDCardPath);
			String SAVE_FOLDER = Environment.getExternalStorageDirectory().getAbsolutePath() + File.separator+"CWBuyer/data/" ;
			String path = SAVE_FOLDER.substring(0, SAVE_FOLDER.length()-1);
			
	        File myDataPath = new File(path);
	        if (myDataPath.exists()){
				File f = new File(path);        
				File file[] = f.listFiles();
				for (int i=0; i < file.length; i++)
				{
					if (file[i].toString().indexOf(".zip")>0){
					Utilis.DeleteFile(SAVE_FOLDER+file[i].getName());
				    //LoY,~nR
					}
				}
	        }
			
			String DBPath=tSDCardPath+getIni(context,"SYS","YEAR",4);
			String DBjPath=DBPath.replace(".sdb",".sdb-journal");
			String DBm=DBPath.replace("cwbuyerpos","qmtrio");
			String DBmj=DBm.replace(".sdb",".sdb-journal");
			String DBini=tSDCardPath+File.separator+"cwbuyer/PARA/ini.sdb";
			String DBiniJ=DBini.replace(".sdb",".sdb-journal");
			tDBZipPath = tDataPath +getIni(context,"SYS","BACKOUT",6).replace(".sdb","_"+DateUtil.getSystemTime().substring(3, 10)+".zip");
			//cwbuyer/data/AA1_cwbuyerpos.sdb
    		StringBuffer zipList =new StringBuffer();
    		
    		File tDBPath = new File(DBPath);
    		if (tDBPath.exists()) zipList.append(DBPath);
    		
    		File tDBjPath = new File(DBjPath);
   			if (tDBjPath.exists()) zipList.append("A"+DBjPath);
   			
    		File tDBm = new File(DBm);
    		if (tDBm.exists()) zipList.append("A"+DBm);
    		
    		File tDBmj = new File(DBmj);
   			if (tDBmj.exists()) zipList.append("A"+DBmj);
   			
   			File tDBiPath = new File(DBini);
   			if (tDBiPath.exists()) zipList.append("A"+DBini);
			Toast.makeText(context,tDBiPath.toString() , Toast.LENGTH_SHORT).show();
			
   			File tDBiiPath = new File(DBiniJ);
   			if (tDBiiPath.exists()) zipList.append("A"+DBiniJ);
			Toast.makeText(context,DBiniJ , Toast.LENGTH_SHORT).show();
			
    		//ؼдNO CWBUYERPOS,INI SDB
			// ѧOwؿO_sbAfalsehإߡF
			Toast.makeText(context,zipList.toString() , Toast.LENGTH_SHORT).show();
   			
			if (zipList.toString().length()>0){
			String[] arrayZipF =  zipList.toString().split("A");
			
			try {
				int BUFFER = 2048;
				BufferedInputStream origin = null;
				FileOutputStream dest = new FileOutputStream(tDBZipPath);
				ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(dest));
				byte data[] = new byte[BUFFER];
				
				for (int i = 0; i < arrayZipF.length; i++) {
					Log.v("Compress", "Adding: " + arrayZipF[i]);
					FileInputStream fi = new FileInputStream(arrayZipF[i]);
					origin = new BufferedInputStream(fi, BUFFER);
					if (arrayZipF[i].indexOf("/data")>0){
						ZipEntry entry = new ZipEntry(arrayZipF[i].substring(arrayZipF[i].indexOf("/data")+1));
						out.putNextEntry(entry);
					}else if (arrayZipF[i].indexOf("/PARA")>0){
						ZipEntry entry = new ZipEntry(arrayZipF[i].substring(arrayZipF[i].indexOf("/PARA")+1));
						out.putNextEntry(entry);
					}
					int count;
					while ((count = origin.read(data, 0, BUFFER)) != -1) {
						out.write(data, 0, count);
					}
					origin.close();
				}
				out.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			//toZipF(context,arrayZipF, tDBZipPath);
			}else{
				tDBZipPath="";	
			}
		} catch (Exception e) {
			Log.i("CopyDBException", e.getMessage());
			tDBZipPath="";
			Toast.makeText(context, "ƮwץX ", Toast.LENGTH_SHORT).show();
		}
		return tDBZipPath;
	}
	
	
	public static String getStringSet(Context context, final String strTag, String defValue){
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
		String value = pref.getString(strTag, defValue);
		return value;
	}
	
	public static Integer getIntSet(Context context, String name, Integer defValue) {
		try {
			SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
			return pref.getInt(name, defValue);
		} catch (Exception e) {
			Log.i("EngKing", "getStringSet_Exception: " + e.toString());
			return 0;
		}
	}
	
	public static Boolean getBooleanSet(Context context, String name, boolean defValue) {

		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
	    return pref.getBoolean(name, defValue);
	  }
	
	public static Float getFloatSet(Context context, String name, Float defValue) {
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
	    return pref.getFloat(name, defValue);
	  }
	
	public static Long getLongSet(Context context, String name, Long defValue) {
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
	    return pref.getLong(name, defValue);
	  }
	
	public static void setStringSet(Context context, final String strTag, String defValue){
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
		SharedPreferences.Editor mEditor = pref.edit();
		mEditor.putString(strTag, defValue);
		mEditor.commit();
	}
	
	public static void setIntSet(Context context, String name, Integer defValue) {
	    SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
	    SharedPreferences.Editor mEditor = pref.edit();
	    mEditor.putInt(name, defValue);
	    mEditor.commit();
	  }
	
	public static void setLongSet(Context context, String name, Long defValue) {
	    SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
	    SharedPreferences.Editor mEditor = pref.edit();
	    mEditor.putLong(name, defValue);
	    mEditor.commit();
	  }
	
	public static void setFloatSet(Context context, String name, Float defValue) {
	    SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
	    SharedPreferences.Editor mEditor = pref.edit();
	    mEditor.putFloat(name, defValue);
	    mEditor.commit();
	}
	
	public static void setBooleanSet(Context context, String name, Boolean defValue) {
//		SharedPreferences pref = context.getSharedPreferences(PrefKey.NAME, 0);
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(context);
	    SharedPreferences.Editor mEditor = pref.edit();
	    mEditor.putBoolean(name, defValue);
	    mEditor.commit();
	  }
	
	public static String getShortName(ComponentName cn){
		String className = cn.getClassName();
		int nPos = className.lastIndexOf(".");
		String shortName = className.substring(nPos);
		return shortName;
	}
	
	
	public static String getRealPathFromURI(Activity act, Uri uri){
		
		String[] proj = {MediaStore.Images.Media.DATA};
		
		Cursor actualimagecursor = act.managedQuery(uri,proj,null,null,null);

		int actual_image_column_index = actualimagecursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);

		actualimagecursor.moveToFirst();

		String img_path = actualimagecursor.getString(actual_image_column_index);
		
		return img_path;
	}
	
	
	/**
	 * @param width   return the new Width Bmp 
	 * @param height  return the new Height Bmp
	 * @return Resacle Bitmap
	 */
	public static Bitmap getScaleBitmap(String imagePath, int newWidth, int newHeight){
		 final int COLOR_PIXEL = 3;
		 BitmapFactory.Options option = new BitmapFactory.Options();
	     option.inJustDecodeBounds = true;
	     BitmapFactory.decodeFile(imagePath, option);
	     
	     //Decode again with inSampleSize
	     int maxNumOfPixels = COLOR_PIXEL * newWidth * newHeight;
	     option.inJustDecodeBounds = false;
	     option.inSampleSize = computeSampleSize(option, -1, maxNumOfPixels);
	     
	     try{
	    	 Bitmap bmp = BitmapFactory.decodeFile(imagePath, option);
	    	 
	    	 Bitmap rescaleBmp = Bitmap.createScaledBitmap(bmp, newWidth, newHeight, true);
	    	 return rescaleBmp;
	    	 
	     }catch(OutOfMemoryError e){
	    	 Log.e("Gallery", "BitmapManager->getScaleBitmap() OutOfMemoryError!");
	    	 return null;
	     }
	}
	
	
	/**
	 * @param width   return the new Width Bmp 
	 * @param height  return the new Height Bmp
	 * @return Resacle Bitmap
	 */
	public static Bitmap getLimitBitmap(String imagePath, int maxWidth, int maxHeight){
		 final int COLOR_PIXEL = 3;
		 File file=new File(imagePath);
		 if (!file.exists() || imagePath.length()<=0){return null;}  
		 BitmapFactory.Options option = new BitmapFactory.Options();
	     option.inJustDecodeBounds = true;
	     BitmapFactory.decodeFile(imagePath, option);
	     
	     int w = option.outWidth;
	     int h = option.outHeight;
	     int maxNumOfPixels =0;
	     
	     maxNumOfPixels = COLOR_PIXEL * maxWidth * maxHeight;
	     option.inJustDecodeBounds = false;
	     int nSampleSize = computeSampleSize(option, -1, maxNumOfPixels);
	     
	     option.inSampleSize = nSampleSize;
	     
	     try{
	    	 Bitmap bmp = BitmapFactory.decodeFile(imagePath, option);
	    	 return bmp;
	    	 
	     }catch(OutOfMemoryError e){
	    	 Log.e("Gallery", "BitmapManager->getScaleBitmap() OutOfMemoryError!");
	    	 return null;
	     }
	}
	
	
	public static int computeSampleSize(BitmapFactory.Options options,
	        int minSideLength, int maxNumOfPixels) {
	    int initialSize = computeInitialSampleSize(options, minSideLength,
	            maxNumOfPixels);

	    int roundedSize;
	    if (initialSize <= 8) {
	        roundedSize = 1;
	        while (roundedSize < initialSize) {
	            roundedSize <<= 1;
	        }
	    } else {
	        roundedSize = (initialSize + 7) / 8 * 8;
	    }

	    return roundedSize;
	}
	
	private static int computeInitialSampleSize(BitmapFactory.Options options,
	        int minSideLength, int maxNumOfPixels) {
	    double w = options.outWidth;
	    double h = options.outHeight;

	    int lowerBound = (maxNumOfPixels == -1) ? 1 :
	            (int) Math.ceil(Math.sqrt(w * h / maxNumOfPixels));
	    int upperBound = (minSideLength == -1) ? 128 :
	            (int) Math.min(Math.floor(w / minSideLength),
	            Math.floor(h / minSideLength));

	    if (upperBound < lowerBound) {
	        // return the larger one when there is no overlapping zone.
	        return lowerBound;
	    }

	    if ((maxNumOfPixels == -1) &&
	            (minSideLength == -1)) {
	        return 1;
	    } else if (minSideLength == -1) {
	        return lowerBound;
	    } else {
	        return upperBound;
	    }
	}
	
	public static void checkPicSize(String picPath){
		File filePic= new File(picPath);
	  if (filePic.exists()){//ɦsb
		if (filePic.length()>=500000){ 
			Bitmap mBitmap = Utilis.getScaleBitmap(picPath, 210, 280);
	        FileOutputStream fos = null;
	        try {
				fos = new FileOutputStream(picPath);
			} catch (FileNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			try {
				mBitmap.compress(CompressFormat.JPEG, 100, fos);
				fos.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	  }
	}
	
	public static Bitmap getSmallPic(String filepath)
	{
	      //The new size to decode to 
//	      final int NEW_SIZE=100; [R]nouse
	      //Only decode image size. Not whole image
	      BitmapFactory.Options option = new BitmapFactory.Options();
	      option.inJustDecodeBounds = true;
	      BitmapFactory.decodeFile(filepath, option);
	      //Now we have image width and height. We should find the correct scale value. (power of 2)
	      int width=option.outWidth;
	      int height=option.outHeight;
	      int scale=1;
	      int max,min;
	      max=213; //[R]max=160
	      min=142; //[R]min=120
	      while(true){
	          if(width>height){max=width;} else {max=height;}
	          if(max/2<min || max/2<min)
	              break;
	          width/=2;
	          height/=2;
	          scale++;
	      }
	      scale++;

	      //Decode again with inSampleSize
	      option = new BitmapFactory.Options();
	      option.inJustDecodeBounds = false;
//	      option.inSampleSize=scale;
	      option.inSampleSize=20;
//	      option.inPurgeable=true;
//	      option.inInputShareable=true;
	       
	      return  BitmapFactory.decodeFile(filepath,option);		
	}
	
	
	public static String getMonthDate(){
    	StringBuffer buf = new StringBuffer();
    	int nYear1 = 0;
    	int nMonth1 = 0;
    	int nDay1 = 0;
    	int nYear2 = 0;
    	int nMonth2 = 0;
    	int nDay2 = 0;
    	Calendar c = Calendar.getInstance();
    	
    	c.set(Calendar.DAY_OF_MONTH, 1); // 
    	
    	nYear1 = c.get(Calendar.YEAR);
		nMonth1 = c.get(Calendar.MONTH) + 1;
		nDay1 = c.get(Calendar.DAY_OF_MONTH);
		
		c.add(Calendar.MONTH, 1);
		c.add(Calendar.DATE, -1);   // 
		
		nYear2 = c.get(Calendar.YEAR);
		nMonth2 = c.get(Calendar.MONTH) + 1;
		nDay2 = c.get(Calendar.DAY_OF_MONTH);
		
		buf.append(nYear1).append("/");
    	buf.append(Utilis.format(nMonth1)).append("/");
    	buf.append(Utilis.format(nDay1)).append("~");
    	
    	buf.append(nYear2).append("/");
    	buf.append(Utilis.format(nMonth2)).append("/");
    	buf.append(Utilis.format(nDay2));
    	
    	return buf.toString();
    }
	
	
	public static String getWeekDate(){
    	StringBuffer buf = new StringBuffer();
    	int nYear1 = 0;
    	int nMonth1 = 0;
    	int nDay1 = 0;
    	int nYear2 = 0;
    	int nMonth2 = 0;
    	int nDay2 = 0;
    	
    	Calendar c = Calendar.getInstance();
//    	c.add(Calendar.DAY_OF_MONTH, 1);
    	int day = c.get(Calendar.DAY_OF_WEEK);
    	if(day == Calendar.SUNDAY){
    		c.add(Calendar.DAY_OF_MONTH, -1);
    	}
    	
    	c.set(Calendar.DAY_OF_WEEK, Calendar.MONDAY);
    	c.setTime(c.getTime());
    	
    	nYear1 = c.get(Calendar.YEAR);
    	nMonth1 = c.get(Calendar.MONTH) + 1;
    	nDay1 = c.get(Calendar.DAY_OF_MONTH);
    	
    	buf.append(nYear1).append("/");
    	buf.append(Utilis.format(nMonth1)).append("/");
    	buf.append(Utilis.format(nDay1)).append("~");
    	
    	c.add(Calendar.DAY_OF_MONTH, 6);
    	
    	nYear2 = c.get(Calendar.YEAR);
    	nMonth2 = c.get(Calendar.MONTH) + 1;
    	nDay2 = c.get(Calendar.DAY_OF_MONTH);
    	
    	buf.append(nYear2).append("/");
    	buf.append(Utilis.format(nMonth2)).append("/");
    	buf.append(Utilis.format(nDay2));
    	
    	return buf.toString();
    }
	
	// Ǧ^WʪɶASh^Ǥ
	public static String getRecentDate(Context context){
		String recentDate = null;
		SQLiteDatabase db = Utilis.getDB(context);
		if(db != null){
			try{
				Cursor cursor = db.rawQuery("Select CREATEDATETIME from qdetail Order by CREATEDATETIME Desc limit 1", null);
				if(cursor != null){
					if(cursor.getCount() > 0){
						cursor.moveToFirst();
						recentDate = cursor.getString(0);
						recentDate = recentDate.replace("-", "/");
					}
					cursor.close();
				}
			}catch(Exception e){
				e.printStackTrace();
			}finally{
				db.close();
			}
		}
		if(recentDate == null){
			recentDate = Utilis.getCurrentDate();
		}
		return recentDate;
	}
    
	// Ǧ^WʪɶASh^Ǥ
	public static String getRecentPDate(Context context){
		String recentDate = null;
		SQLiteDatabase db = Utilis.getDB(context);
		if(db != null){
			try{
				Cursor cursor = db.rawQuery("Select FORMDATE from qhead Order by FORMDATE Desc limit 1", null);
				if(cursor != null){
					if(cursor.getCount() > 0){
						cursor.moveToFirst();
						recentDate = cursor.getString(0);
						recentDate = recentDate.replace("-", "/");
					}
					cursor.close();
				}
			}catch(Exception e){
				e.printStackTrace();
			}finally{
				db.close();
			}
		}
		if(recentDate == null){
			recentDate = Utilis.getCurrentDate();
		}
		if (recentDate.indexOf("-")>0) recentDate = recentDate.replace("-", "/");
		
		return recentDate;
	}
    
	public static String getDayDate(){
    	StringBuffer buf = new StringBuffer();
    	int nYear1 = 0;
    	int nMonth1 = 0;
    	int nDay1 = 0;
    	Calendar c = Calendar.getInstance();
    	nYear1 = c.get(Calendar.YEAR);
    	nMonth1 = c.get(Calendar.MONTH) + 1;
    	nDay1 = c.get(Calendar.DAY_OF_MONTH);
    	
    	buf.append(nYear1).append("/");
    	buf.append(Utilis.format(nMonth1)).append("/");
    	buf.append(Utilis.format(nDay1));
    	
//    	buf.append("~");
    	
//    	buf.append(nYear1).append("/");
//    	buf.append(Utilis.format(nMonth1)).append("/");
//    	buf.append(Utilis.format(nDay1));
    	
    	return buf.toString();
    }

	//
	public static double dedb (double dout, int n ){
		double dreturn=dout;
		BigDecimal bd= new BigDecimal(dout);   
		dreturn=bd.setScale(n, BigDecimal.ROUND_HALF_UP).doubleValue();// pƫ᭱n, |ˤJ
		return  dreturn;
	}
	
	// pIĤG
	public static float formatFloat(Float nFloat){
		try{
			StringBuffer buf = new StringBuffer();
			String strFloat = String.valueOf(nFloat);
			String[] strFormat = new String[2];
			int nFind  = strFloat.indexOf("."); // MpI
			if(nFind >= 0){
				strFormat[0] = strFloat.substring(0, nFind);
				strFormat[1] = strFloat.substring(nFind + 1, strFloat.length());
			}else{
				strFormat[0] = strFloat;
				strFormat[1] = "0";
			}
			buf.append(strFormat[0]);
			if(strFormat.length >= 2){
				
				if(strFormat[1].length() >= 2){
					// T{Ĥ@ĤG쳣 0 h^ ʤ
					if(strFormat[1].charAt(0) == '0' && strFormat[1].charAt(1) == '0'){
//						return buf.toString();
					}else{
						buf.append(".");
						buf.append(strFormat[1].charAt(0));
						buf.append(strFormat[1].charAt(1));
					}
				}else{
					if(strFormat[1].length() > 0  && strFormat[1].charAt(0) != '0'){
						buf.append(".").append(strFormat[1].charAt(0));
					}
				}
			}
			return Float.valueOf(buf.toString());
		}catch(Exception e){
			return nFloat;
		}
	}
	
	
	// pIĤG
	public static String getFloatString(Float nFloat){
		try{
			StringBuffer buf = new StringBuffer();
			String strFloat = String.valueOf(nFloat);
			int nFind  = strFloat.indexOf("."); // MpI
			String[] strFormat = new String[2];
			if(nFind >= 0){
				strFormat[0] = strFloat.substring(0, nFind);
				strFormat[1] = strFloat.substring(nFind + 1, strFloat.length());
			}else{
				strFormat[0] = strFloat;
				strFormat[1] = "0";
			}
//			String[] strFormat = strFloat.split("."); // pI
			if(strFormat.length >= 2){
				buf.append(strFormat[0]);
				if(strFormat[1].length() >= 2){
					// T{Ĥ@ĤG쳣 0 h^ ʤ
					if(strFormat[1].charAt(0) == '0' && strFormat[1].charAt(1) == '0'){
//						return buf.toString();
					}else{
						buf.append(".");
						buf.append(strFormat[1].charAt(0));
						buf.append(strFormat[1].charAt(1));
					}
				}else{
					if(strFormat[1].length() > 0  && strFormat[1].charAt(0) != '0'){
						buf.append(".").append(strFormat[1].charAt(0));
					}
				}
				return buf.toString();
			}else{
				return strFloat;
			}
		}catch(Exception e){
			return String.valueOf(nFloat);
		}
	}
	
	//  ZIP }Ҫ Intent
	public static Intent getZipFileIntent(String param) {
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		Uri uri = Uri.fromFile(new File(param));
		intent.setDataAndType(uri, "application/zip");
		return intent;
	}
	
	//  RAR }Ҫ Intent
	public static Intent getRarFileIntent(String param) {
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		Uri uri = Uri.fromFile(new File(param));
		intent.setDataAndType(uri, "application/x-rar-compressed");
		return intent;
	}  
	
	//  Image }Ҫ intent
	public static Intent getImageFileIntent( String param )  
	{  
	    Intent intent = new Intent("android.intent.action.VIEW");  
	    intent.addCategory("android.intent.category.DEFAULT");  
	    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);  
	    Uri uri = Uri.fromFile(new File(param ));  
	    intent.setDataAndType(uri, "image/*");  
	    return intent;  
	}  

	//  Pdf }Ҫ Intent
	public static Intent getPdfFileIntent(String param)
	{
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		Uri uri = Uri.fromFile(new File(param));
		intent.setDataAndType(uri, "application/pdf");
		return intent;
	}

	//  Word }Ҫ Intent
	public static Intent getWordFileIntent(String param) {
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		Uri uri = Uri.fromFile(new File(param));
		intent.setDataAndType(uri, "application/msword");
		return intent;
	}  

	//  Excel }Ҫ Intent
	public static Intent getExcelFileIntent(String param) {
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		Uri uri = Uri.fromFile(new File(param));
		intent.setDataAndType(uri, "application/vnd.ms-excel");
		return intent;
	}
	
	
	//  PPT }Ҫ Intent
	public static Intent getPPTFileIntent(String param) {
		Intent intent = new Intent("android.intent.action.VIEW"); 
	    intent.addCategory("android.intent.category.DEFAULT"); 
	    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK); 
	    Uri uri = Uri.fromFile(new File(param )); 
	    intent.setDataAndType(uri, "application/vnd.ms-powerpoint"); 
	    return intent; 
	}
	   
	// Ψӥ}奻 Intent   
	public static Intent getTextFileIntent(String param, boolean paramBoolean)
	{
		Intent intent = new Intent("android.intent.action.VIEW");
		intent.addCategory("android.intent.category.DEFAULT");
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		if (paramBoolean) {
			Uri uri1 = Uri.parse(param);
			intent.setDataAndType(uri1, "text/plain");
		} else {
			Uri uri2 = Uri.fromFile(new File(param));
			intent.setDataAndType(uri2, "text/plain");
		}
		return intent;
	} 
	
	public static boolean isTimeServiceRunning(Context cnt) {
		ActivityManager manager = (ActivityManager) cnt.getSystemService(cnt.ACTIVITY_SERVICE);
		for (RunningServiceInfo service : manager
				.getRunningServices(Integer.MAX_VALUE)) {
			if ("com.salesbook.main.MainService".equals(service.service.getClassName())) {
				return true;
			}
		}
		return false;
	}
	
	public static double toDouble(String number){
		if(number == null || number.length() <= 0){
			return 0;
		}else{
			try{
				return Double.valueOf(number.trim());
			}catch(Exception e){
				e.printStackTrace();
				return 0;
			}
		}
	}
	
	public static int toInt(String number){
		try{
			if(number == null || number.length() <= 0){
				return 0;
			}else{
				try{
					if (number.indexOf("%")>0) number=number.substring(0,number.indexOf("%"));
					if (number.indexOf(".")>0) number=number.substring(0,number.indexOf("."));
					return Integer.valueOf(number.trim());
				}catch(Exception e){
					e.printStackTrace();
					return 0;
				}
			}
		}catch(Exception e){
			return 0;
		}
	}
	
	public static long toLong(String number){
		if(number == null || number.length() <= 0){
			return 0;
		}else{
			try{
				return Long.valueOf(number.trim());
			}catch(Exception e){
				e.printStackTrace();
				return 0;
			}
		}
	}
	
	//YZIP
	public static void toZipF(Context context,String[] files, String destZip) {
		try {
			int BUFFER = 2048;
			BufferedInputStream origin = null;
			FileOutputStream dest = new FileOutputStream(destZip);
			ZipOutputStream out = new ZipOutputStream(new BufferedOutputStream(dest));
			byte data[] = new byte[BUFFER];
			for (int i = 0; i < files.length; i++) {
				Log.v("Compress", "Adding: " + files[i]);
				FileInputStream fi = new FileInputStream(files[i]);
				origin = new BufferedInputStream(fi, BUFFER);
				
				ZipEntry entry = new ZipEntry(files[i].substring(files[i].indexOf(Utilis.getIni(context, "SYS","YEAR", 7))+Utilis.getIni(context, "SYS","YEAR", 7).length()+1));
				out.putNextEntry(entry);
				int count;
				while ((count = origin.read(data, 0, BUFFER)) != -1) {
					out.write(data, 0, count);
				}
				origin.close();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	
	  // Y _function 2
		public static void Unzip2(String zipFileName, String outputDirectory)
				throws Exception {
			String TAG="______________####__________";
			ZipInputStream in = new ZipInputStream(new FileInputStream(zipFileName));
			ZipEntry z;
			String name = "";
			String extractedFile = "";
			int counter = 0;
			while ((z = in.getNextEntry()) != null) {
				name = z.getName();
				Log.d(TAG, "unzipping file: " + name);
				if (z.isDirectory()) {
					Log.d(TAG, name + "is a folder");
					File folder = new File(outputDirectory + File.separator + name);
					folder.mkdir();
					if (counter == 0) {
						extractedFile = folder.toString();
					}
					counter++;
				} else {
					if (name.indexOf("/")>0)
					{
						File folder = new File(outputDirectory + File.separator+name.substring(0, name.lastIndexOf("/")));
						if (!folder.exists()) folder.mkdir();
					}
					File file = new File(outputDirectory + File.separator + name);

					file.createNewFile();
					// get the output stream of the file
					FileOutputStream out = new FileOutputStream(file);
					int ch;
					byte[] buffer = new byte[1024];
					// read (ch) bytes into buffer
					while ((ch = in.read(buffer)) != -1) {
						// write (ch) byte from buffer at the position 0
						out.write(buffer, 0, ch);
						out.flush();
					}
					out.close();
				}
			}
			in.close();
		}
		
		// TOsObX
		public static String formatNumber(String s, int x) {
			StringBuffer buf = new StringBuffer();
			if(x > 0){
				int length = s.length();
				if (length == 0){
					for(int i = 0; i < x; i ++){
						buf.append("0");
					}
					s = buf.toString();
				}else{
					for(;length < x; length++){
						buf.append("0");
					}
					buf.append(s);
				}
				return buf.toString();
			}else{
				return s;
			}
		}

		public static String getIni(Context context,String Obj,String Key,int mode){
			//Obj,Key,Index Ӧ,_h^
			String value=null;		
		    try {
			      File file = new File(android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+ "/cwbuyer/para/ini.sdb");
			      SQLiteDatabase db = SQLiteDatabase.openOrCreateDatabase(file, null);
			      
			      StringBuffer mBuf = new StringBuffer();
			      mBuf.append("select * from system where OBJ='"+Obj+"' and KEY='"+Key+"'");
			      Cursor cs = db.rawQuery(mBuf.toString(), null);
			      if (cs.getColumnCount()>0){
			    	  cs.moveToFirst();
			    	  int index = cs.getInt(cs.getColumnIndex("POINT"));
			    	  if(mode==0){ //w]
			    		  value=cs.getString(index+3);
			    	  } else if (mode>=1 && mode <=8){
			    		  value=cs.getString(mode+3);  //wnD
			    	  }else if(mode==9){ //Ʊa^  
			    		  StringBuffer Buf = new StringBuffer();
			    		  Buf.append(cs.getString(cs.getColumnIndex("T1"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T2"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T3"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T4"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T5"))+",")		    		  
			    		  .append(cs.getString(cs.getColumnIndex("T6"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T7"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T8"))+",")
			    		  .append(cs.getString(cs.getColumnIndex("T9")));
			    		  value=Buf.toString();
			    	  }
			      }
			      cs.close();
			      db.close();
		    } catch (SQLException e) {
			      return null;	    	
		    }
			return value;
		}

		public static void putIni(Context context,String Obj,String Key,String value,int mode){
			//Obj,Key,Index Ӧ,_h^
		    try {
			      File file = new File(android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+ "/cwbuyer/para/ini.sdb");
			      SQLiteDatabase db = SQLiteDatabase.openOrCreateDatabase(file, null);
			      
			      StringBuffer mBuf = new StringBuffer();
			      mBuf.append("update system set T"+mode+"='"+value+"'")
			      .append(" where OBJ='"+Obj+"' and KEY='"+Key+"'");
			      db.execSQL(mBuf.toString());
			      db.close();
		    } catch (SQLException e) {
		    }
		}
		
		public static String makeSPics(Context context,String BigPic){
			 int px=210;
			 int py=280;
			 String nFile=BigPic;
//		 if(BigPic.indexOf("drawable/") < 0) {
			 File myDataPath = new File(nFile.substring(0,nFile.lastIndexOf("/")));			 
//			 myDataPath = new File(nFile.substring(0,nFile.lastIndexOf("")));			 
		        if (!myDataPath.exists()) {
		            myDataPath.mkdirs();
		          }
			 
			 Bitmap vBitmap = Bitmap.createBitmap( px,py, Bitmap.Config.RGB_565);		 
			File file = new File(BigPic);
			if ((file.exists() == true && file.length()>100000) || (nFile.equalsIgnoreCase(BigPic)==false)) {
				vBitmap=Utilis.getLimitBitmap(BigPic, px, py);
				Bitmap rsizePic=vBitmap;
					 
					 ByteArrayOutputStream stream = new ByteArrayOutputStream();
				        FileOutputStream fos = null;
						try {
							fos = new FileOutputStream(nFile);
							
						} catch (FileNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
				    try {
						int swidth = vBitmap.getWidth();
						int shgh = vBitmap.getHeight();
						
						Matrix scaleMatrix = new Matrix();
						scaleMatrix.postScale(1,1);
						rsizePic =Bitmap.createBitmap(vBitmap, 0, 0, swidth, shgh, scaleMatrix, true);
						rsizePic.compress(Bitmap.CompressFormat.JPEG, 100, stream);
						rsizePic.compress(CompressFormat.JPEG, 100, fos);
						fos.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			}
//		 }
			return nFile;
		 }

		//os渹
		public static String getNFormno(Context context,String formf){
			int flowNumber = 0;
			String msFno=Utilis.getIni(context,"SYS","DEPT",1)+Utilis.getIni(context,"SYS","DEPT",2)+formf+Utilis.getCurrentYearFormat().substring(0, 1);
			//Ӧ~ 2X Ӧb2020~_ n.substring(0, 2);
			SQLiteDatabase db = Utilis.getDB(context);
			try{
				Cursor cursor = db.rawQuery("select FORMNO from " + TbName.QHEAD + " where FORMNO like '"+msFno+"%' order by FORMNO DESC limit 1", null);
				if(cursor != null){
					try{
						if(cursor.getCount() > 0){
							cursor.moveToFirst();
							flowNumber = Utilis.toInt(cursor.getString(cursor.getColumnIndex("FORMNO")).substring(msFno.length()))+1;
						}
					}catch(Exception e){
						e.printStackTrace();
					}
					cursor.close();
				}else{ //s}l渹
					flowNumber=1;
				}
			}catch(Exception e){
				e.printStackTrace();
			}
			if(db != null){
				db.close();
			}
			return msFno+Utilis.formatFlow(flowNumber);
		}
		
		//os渹
		//w] sb Utilis.getIni(this,"HOST","MAXITEM",5);
		public static String getNadord(Context context){
			int flowNumber = 0;
			String msFno=Utilis.getIni(context,"HOST","MAXITEM",5);
			String mRETURN=msFno;
			SQLiteDatabase db = Utilis.getDB(context);
			try{
				Cursor csH =db.rawQuery("select EMPNAME from " + TbName.QHEAD + " where EMPNAME ='"+msFno+"' and QKIND='20' and ISCONFIRM='N' and ISCHECK='N' and ATOT<>0 order by EMPNAME DESC limit 1", null);
				//Hw]帹,ˬdO_btf
					try{
						if(csH.getCount() > 0){
							//ܥbtf
							mRETURN=msFno;
						}else{
							//|
							Cursor cs= db.rawQuery("select EMPNAME from " + TbName.QHEAD + " where QKIND='20' and ISCONFIRM='N' and ISCHECK='N' and ATOT>0 and EMPNAME>'00101001' and EMPNAME<'91231999' order by EMPNAME DESC limit 1", null);
								try{
									if(cs.getCount() > 0){
										cs.moveToFirst();
										mRETURN=cs.getString(0);
										if (!Utilis.getIni(context,"HOST","MAXITEM",5).equalsIgnoreCase(mRETURN))
											Utilis.putIni(context,"HOST","MAXITEM", mRETURN, 5);
									}else{
										//wפF,ss
										msFno=Utilis.getCurrentYearFormat().substring(0, 5);
										Cursor cursor = db.rawQuery("select EMPNAME from " + TbName.QHEAD + " where EMPNAME like '"+msFno+"%' and QKIND='20' order by EMPNAME DESC limit 1", null);
										try{
											if(cursor.getCount() > 0){
												cursor.moveToFirst();
												flowNumber = Utilis.toInt(cursor.getString(cursor.getColumnIndex("EMPNAME")).substring(msFno.length()))+1;
											}else{ //s}l渹
												flowNumber=1;
											}
										}catch(Exception e){
											e.printStackTrace();
										}
										cursor.close();
										mRETURN=msFno+Utilis.ordFlow(flowNumber);
										Utilis.putIni(context,"HOST","MAXITEM", mRETURN, 5);
									}
								}catch(Exception e){
									e.printStackTrace();
								}
								cs.close();
						}
					}catch(Exception e){
						e.printStackTrace();
					}
				csH.close();
			}catch(Exception e){
				e.printStackTrace();
			}
			if(db != null){
				db.close();
			}
			return mRETURN;
		}
		
		
		public static String makeSPic(Context context,String BigPic,String batch){
			 int px=210;
			 int py=280;
			 String nFile=android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+getIni(context,"SYS", "YEAR",7)+File.separator+batch+"/"+BigPic.substring(BigPic.lastIndexOf("/")+1,BigPic.lastIndexOf("."))+".jpg";
//		 if(BigPic.indexOf("drawable/") < 0) {
			 File myDataPath = new File(nFile.substring(0,nFile.lastIndexOf("/")));			 
//			 myDataPath = new File(nFile.substring(0,nFile.lastIndexOf("")));			 
		        if (!myDataPath.exists()) {
		            myDataPath.mkdirs();
		          }
			 
			 Bitmap vBitmap = Bitmap.createBitmap( px,py, Bitmap.Config.RGB_565);		 
			File file = new File(BigPic);
			if ((file.exists() == true && file.length()>100000) || (nFile.equalsIgnoreCase(BigPic)==false)) {
				vBitmap=Utilis.getLimitBitmap(BigPic, px, py);
				Bitmap rsizePic=vBitmap;
					 
					 ByteArrayOutputStream stream = new ByteArrayOutputStream();
				        FileOutputStream fos = null;
						try {
							fos = new FileOutputStream(nFile);
							
						} catch (FileNotFoundException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						
				    try {
						int swidth = vBitmap.getWidth();
						int shgh = vBitmap.getHeight();
						
						Matrix scaleMatrix = new Matrix();
						scaleMatrix.postScale(1,1);
						rsizePic =Bitmap.createBitmap(vBitmap, 0, 0, swidth, shgh, scaleMatrix, true);
						rsizePic.compress(Bitmap.CompressFormat.JPEG, 100, stream);
						rsizePic.compress(CompressFormat.JPEG, 100, fos);
						fos.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			}
//		 }
			return nFile;
		 }

	public static void startPrint(Context cnt,StringBuffer sPrintB,int Loca ){
		if (sPrintB.toString().length()>0){
//			final String myImportPath =android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+Utilis.getIni(cnt, "SYS", "YEAR",7);	
			String lenS="0000"+(int)(Loca/7.32);
			sPrintB.replace(2, 6,lenS.substring(lenS.length()-4,lenS.length()));
			sPrintB.append("E\r\n");
	        boolean Succed=false;
			String address=null;
			int port=0;
			   address = Utilis.getIni(cnt, "SYS","BAR_IP", 4);// suip
			   port =Utilis.toInt(Utilis.getIni(cnt, "SYS","BAR_IP", 5));// suport
				 InetAddress serverAddr = null;
			        SocketAddress sc_add = null;
			        Socket socket = null;

						 try {
							 serverAddr = InetAddress.getByName(address);
							 sc_add= new InetSocketAddress(serverAddr,port);
								 socket = new Socket();
								 socket.connect(sc_add,6000);
								 DataOutputStream out = new DataOutputStream(socket.getOutputStream());
								 byte data[] = new String(sPrintB.toString().getBytes("UTF8")).getBytes("BIG5");
								 out.write(data, 0, data.length);
								 socket.close();
								 Toast.makeText(cnt, "w\ǰeTX!!", Toast.LENGTH_LONG).show();
								 Succed=true;
						 } catch (UnknownHostException e) {
							 Succed=false;
						 } catch (SocketException e) {
							 Succed=false;
						 } catch(IOException e) {
							 Succed=false;
						 }
			}
		
		
	}
		
	public static void openCashDraw(Context cnt){
		String address=null;
		int port=0;
		   address = Utilis.getIni(cnt, "SYS","BAR_IP", 6);// suip
		   port =Utilis.toInt(Utilis.getIni(cnt, "SYS","BAR_IP", 7));// suport

	 InetAddress serverAddr = null;
        SocketAddress sc_add = null;
        Socket socket = null;
		String FormD=Utilis.getCurrentDate();  //2012-10-22
		int Ttime=Utilis.toInt(DateUtil.getSystemTime().substring(8, 10));  //oثeXI
		String[] deptStr =Utilis.getIni(cnt,"SYS","DEPT",9).split(",");
	if (Ttime<=5)  FormD = Utilis.addDate(FormD, -1);

			 try {
				 serverAddr = InetAddress.getByName(address);
				 sc_add= new InetSocketAddress(serverAddr,port);
					 socket = new Socket();
					 socket.connect(sc_add,2000);
					 DataOutputStream out = new DataOutputStream(socket.getOutputStream());
					 byte data[] = new String(((char)27+"p"+(char)0+(char)100+(char)250).getBytes("UTF8")).getBytes("BIG5");
					 out.write(data, 0, data.length);
					 socket.close();
						SQLiteDatabase db = Utilis.getDB(cnt);
						ContentValues value = new ContentValues();
				    	value.put("TR", "0");
				    	value.put("ID", 0);
				    	value.put("QKIND", "80");
				    	value.put("FORMNO", deptStr[0]+deptStr[1]+"8"+Utilis.getCurrentYearFormat().substring(0, 2));
				    	value.put("FORMDATE", FormD);
				    	value.put("CTIME", DateUtil.getSystemTime().substring(2,14));
				    	value.put("UTIME", DateUtil.getSystemTime().substring(2,14));
				    	value.put("ISCONFIRM", "Y"); //"O"
				    	value.put("QATYPE", "}d");
				    	value.put("QNOM", "9600");
				    	value.put("QNOI", "");
				    	value.put("PS", "");
				    	value.put("MOUT", 0);
				    	value.put("MINTO", 0);
				    	value.put("MBEFORE", 0);
				    	value.put("MBALANCE", 0);
				    	value.put("MBETWEEN", 0);
				    	value.put("MAFTER", 0);
				    	value.put("DEPTNO", deptStr[0]);
				    	value.put("DEPTNAME", deptStr[2]);
				    	value.put("DEVISE", deptStr[1]);
				    	value.put("ATMNO", "");
				    	value.put("ATMNAME", "");
				    	value.put("ATMDATE", "");
				    	value.put("EMPID", "000");
				    	value.put("EMPNAME", "d}F");
				    	value.put("PIC", "drawable.icon");
				    	value.put("BANKNAME", deptStr[0]+deptStr[1]);

				    	long result = db.insert(TbName.QMACC, null, value);
				    	
				    	db.close();
					 
					 Toast.makeText(cnt, "d}ҤF!!", Toast.LENGTH_LONG).show();
					 //LsJ@ qmacc }d
					 //NX 9600 HUxs@

			 } catch (UnknownHostException e) {

			 } catch (SocketException e) {
				 Toast.makeText(cnt, "dsu!!", Toast.LENGTH_LONG).show();
			 } catch(IOException e) {
				 Toast.makeText(cnt, "ɮ׶}ҥ!!", Toast.LENGTH_LONG).show();
			 }
	}

	//  SpinerDialog
	public static void showDialogCancel(Context cnt, String title, int select,
			final String[] array, final IDialog callback) {
		new AlertDialog.Builder(cnt)
				.setTitle(title)
				.setSingleChoiceItems(array, select,
						new DialogInterface.OnClickListener() {
							@Override
							public void onClick(DialogInterface dialog,
									int which) {
								// ((TextView)findViewById(R.id.text_choice)).setText(strString[which]);
								callback.onDialogFinish(which, array[which]);
								dialog.dismiss();
							}
						})
				.setNegativeButton("", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int which) {
						dialog.dismiss();
					}
				}).create().show();
	}
}